/****************************************************************************
** Dooble - The Secure Internet Web Browser
**
** Copyright (c) 2008, 2009, 2010 Alexis Megas,
** Gunther van Dooble, and the Dooble Team.
** All rights reserved.
**
** License: GPL2 only:
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; version 2 of the License only.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
** or see here: http://www.gnu.org/licenses/gpl.html
**
** For the WebKit library, please see: http://webkit.org.
**
** THE CODE IS PROVIDED BY THE AUTHORS ''AS IS'' AND ANY
** EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
** ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
** GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
** IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS APPLICATION, EVEN IF ADVISED
** OF THE POSSIBILITY OF SUCH DAMAGE.
**
** Please report all praise, requests, bugs, and problems to the project
** team and administrators: http://sf.net/projects/dooble.
**
** You can find us listed at our project page. New team members are welcome.
** The name of the authors should not be used to endorse or promote products
** derived from Dooble without specific prior written permission.
** If you use this code for other projects, please let us know.
**
** Web sites:
**   http://sf.net/projects/dooble
**   http://dooble.sf.net
****************************************************************************/

#ifndef _dfilemanager_h_
#define _dfilemanager_h_

#include <QUrl>
#include <QList>
#include <QWidget>
#include <QWebHistory>
#include <QFileSystemModel>

#include "dwebhistory.h"
#include "dwebhistoryitem.h"
#include "dfilesystemmodel.h"
#include "ui_fileManagerForm.h"

class dfilemanager: public QWidget
{
  Q_OBJECT

 public:
  dfilemanager(QWidget *parent);
  ~dfilemanager();
  static QFileSystemModel *treeModel;
  static dfilesystemmodel *tableModel;
  QUrl url(void) const;
  void back(void);
  void load(const QUrl &url);
  void reload(void);
  void forward(void);
  QString html(void) const;
  QString title(void) const;

 public:
  dwebhistory *history(void)
  {
    return m_history;
  }

 private:
  QUrl m_url;
  QString pathLabelPlainText;
  dwebhistory *m_history;
  Ui_FileManagerForm ui;
  void menuAction(const QString &action, QAbstractItemView *view);
  void prepareLabel(const QUrl &url);
  void keyPressEvent(QKeyEvent *event);
  void deleteSelections(QAbstractItemView *view);

 private slots:
  void slotClicked(const QModelIndex &index);
  void slotCloseEditor(QWidget *editor,
		       QAbstractItemDelegate::EndEditHint hint);
  void slotLabelClicked(const QString &link);
  void slotDoubleClicked(const QModelIndex &index);
  void slotTreeMenuAction(void);
  void slotTableMenuAction(void);
  void slotDirectoryRemoved(const QModelIndex &index, int start, int end);
  void slotSaveTableHeaderState(void);
  void slotCustomContextMenuRequest(const QPoint &pos);

 signals:
  void urlChanged(const QUrl &url);
  void iconChanged(void);
  void loadStarted(void);
  void loadFinished(bool ok);
  void loadProgress(int progress);
  void titleChanged(const QString &title);
};

#endif
